package com.elab.test.netty;

import io.netty.util.HashedWheelTimer;
import io.netty.util.Timeout;
import io.netty.util.TimerTask;

import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

/**
 * 时间轮
 *
 * @author liukaixiong
 * @Email liukx@elab-plus.com
 * @date 2021/12/3 - 14:57
 */
public class HashedWheelTimerSample {

    public static void main(String[] args) {
        final HashedWheelTimer timer =
            new HashedWheelTimer(Executors.defaultThreadFactory(), 100, TimeUnit.MILLISECONDS, 32);

        timer.newTimeout(new TimerTask() {
            @Override
            public void run(final Timeout timeout) throws Exception {
                System.out.println("lee");   //打印名字
            }
        }, 1000, TimeUnit.MILLISECONDS);

        timer.newTimeout(new TimerTask() {
            @Override
            public void run(final Timeout timeout) throws Exception {
                System.out.println("lee2");   //打印名字
            }
        }, 5000, TimeUnit.MILLISECONDS);

        timer.start();
    }
}
